<?php

namespace loyalsoft;

require_once __DIR__ . '/FightProc/SweepGatesProc.php';
require_once __DIR__ . '/FightProc/PVPProc.php';

/**
 * 战斗
 * @author gwang
 */
class FightProc {
    //put your code here

    /**
     * 战斗逻辑分发
     * 所有的Proc中必须有这样一个方法
     * @param Req $req
     */
    static function procMain($req) {
        switch ($req->cmd) {
            # 关卡-征战
            case CmdCode::cmd_fight_arenasfight:                                # 6801 挑战关卡
                return SweepGatesProc::Arenas_Fight($req);
//            case CmdCode::cmd_fight_arenassweep:                              # 6802 扫荡关卡
//                return SweepGatesProc::Arenas_SweepFight($req);
            case CmdCode::cmd_fight_GetArenasStarReward:                        # 6803 扫荡关卡
                return SweepGatesProc::GetArenasStarReward($req);
            case CmdCode::cmd_fight_ConsumeBufferGold:                          # 6804 扣除买buffer费用
                return SweepGatesProc::ConsumeBufferGold($req);
            case CmdCode::cmd_fight_GetborrowedFriend:                          # 6805 查询已经借用过的好友
                return SweepGatesProc::GetBorrowedFriends($req);
            case CmdCode::cmd_fight_BorrowFriend:                               # 6806 扣除借用好友的费用
                return SweepGatesProc::ConsumeBorrowFriend($req);
            case CmdCode::cmd_fight_ChallengeEndlessFightMode:                  # 6807 '黄金之城'无限挑战
                return SweepGatesProc::ChallengeEndlessFightMode_Gold($req);
// ---------------
            case CmdCode::cmd_fight_OpenCarbon:                                 # [6808] 开启副本
                return SweepGatesProc::OpenTheCarbon($req);
            case CmdCode::cmd_fight_ChallengeCarbon:                            # [6809] 挑战副本关卡
                return SweepGatesProc::NewChallengeCarbon($req);
// --------- pvp  -----------------
//            case CmdCode::cmd_fight_pvp_maininfo:                               # [6810] pvp 主界面拉取信息
//                return PVPProc::pvpMainInfo($req);
//            case CmdCode::cmd_fight_pvp_pk:                                     # [6811] pvp 挑战对手
//                return PVPProc::pvp_PK($req);
//            case CmdCode::cmd_fight_pvp_refresh:                                # [6812] pvp 刷新对手
//                return PVPProc::pvp_Refresh($req);
//            case CmdCode::cmd_fight_pvp_chargetili:                             # [6813] pvp 补充体力
//                return PVPProc::pvp_buytili($req);
////                return PVPProc::pvp_recharegetili($req);
//            case CmdCode::cmd_fight_pvp_getrank:                                # [6814] pvp 拉取前100名,排行榜
//                return PVPProc::pvp_getRank($req);
//            case CmdCode::cmd_fight_pvp_drawactivereward:                       # [6815] pvp 领取活跃度奖励
//                return PVPProc::pvp_drawacitverewards($req);
//            case CmdCode::fight_pvp_getChanlianInfo:                            # [6819] pvp 拉取蝉联信息
//                return PVPProc::getChanlianINfo($req);
//  ----------------- 剧情关卡 ----------------------
            case CmdCode::cmd_fight_Challenge_StoryGate:                        # [6816] 挑战剧情关卡
                return SweepGatesProc::ChallengeStoryGate($req);
            //------------------------------------------------
            case CmdCode::cmd_new_arenas_fight:                                 # [6817] 新的挑战关卡
                return Resp::err(ErrCode::function_notopen_msg);
                return SweepGatesProc::NewArenas_Fight($req);
            case CmdCode::cmd_new_arenas_changeStayCity:                        # [6818] 记录玩家到达哪一关的
                return SweepGatesProc::ChangeArenas_StayCity($req);
            case CmdCode::cmd_fight_arenassweep:                                # [6802] 扫荡
                return SweepGatesProc::Arenas_NewSweepFight($req);
            default:
                return Resp::err(ErrCode::cmd_err);
        }
    }

    /**
     * @param Req $req
     */
    static function ClearByDay($req) {
//        SweepGatesProc::ClearFightRentRecord($req);                             # 清理战斗中租借好友记录
//        SweepGatesProc::ClearGateForeverGold_FightCountEveryDay($req);          # 清理无尽模式的战斗次数记录
        SweepGatesProc::ClearGateTimes($req);                                   # 清理每个难度副本的每日战斗次数
//        PVPProc::ClearDailyPkcnt($req);                                       # 清理每日挑战次数计数
    }

}
